/*
* tae.c
* test arithmetic expression package
* this code is hereby placed in the public domain by lhf@tecgraf.puc-rio.br
* 26 Jun 2004 23:45:43
*/

#include <stdio.h>
#include <string.h>
#include "ae.h"

int main(void)
{
 char buffer[BUFSIZ];
 ae_open(1);
 while (fgets(buffer,sizeof(buffer),stdin))
 {
  int rc=0;
  char *s;
  double v;
  printf("> %s",buffer);
  *strchr(buffer,'\n')=0;
  if (*buffer=='#')
   continue;
  else if ((s=strchr(buffer,'='))!=NULL)
  {
   *s=0;
   if (strchr(buffer,'(')!=NULL)
   {
    const char* e;
    *s='=';
    e=ae_fun(buffer);
    if (e) printf("\t%s\n",e);
    continue;
   }
   else
    ae_set(buffer,v=ae_eval(s+1,&rc));
  }
  else if (*buffer=='?')
   v=ae_get(buffer+1);
  else
   v=ae_eval(buffer,&rc);
  if (rc) printf("\t%s\n",ae_error()); else printf("\t%.15g\n",v);
 }
 ae_close();
 return 0;
}
